var typeMap = {
    admin: "The extension was installed because of an administrative policy",
    development: "The extension was loaded unpacked in developer mode",
    normal: "The extension was installed normally via a Chrome Web Store",
    sideload: "The extension was installed by other software on the machine",
    other: "The extension was installed by other means."
};
var popup = {
    createList: function (containerId, name, desc, img, index, disable, id, control, type, permissions, hsotPermission, installType) {
        var name = name.length > 32 ? name.substr(0, 32)+'...' : name;
        $("#" + containerId).append('<li class="mdl-list__item" id="' + id + '" style="position: relative; flex-wrap: wrap;">' +
            '<a target="_blank" href="https://chrome.google.com/webstore/detail/'+id+'" class="mdl-list__item-primary-content">' +
            // '<img src="' + img + '" class="mdl-list__item-avatar"/>' +
            '<span id="title">' + name + '</span>' +
            // '<span class="mdl-list__item-text-body">' + desc + '</span>' +
            '</a>' +
            '<span class="mdl-list__item-primary-action mr-4 ml-3">' +
            '<label class="mdl-switch mdl-js-switch mdl-js-ripple-effect" for="list-switch-' + index + '" id="disable-tooltip-' + index + '">' +
            '<input type="checkbox" id="list-switch-' + index + '" data-id="' + id + '" data-index="' + index + '" class="mdl-switch__input" ' + disable + '/>' +
            '</label>' +
            '</span>' +
            '<span class="mdl-list__item-secondary-action btn-delete" data-id="' + id + '" data-index="' + index + '" id="delete-tooltip-' + index + '">' +
            '<i class="material-icons">delete</i>' +
            '</span>' +
            '<span class="mdl-list__item-secondary-action btn-details" data-id="' + id + '" data-index="' + index + '" id="detail-tooltip-' + index + '">' +
                '<i class="material-icons">keyboard_arrow_down</i>' +
            '</span>' +
            '<div class="mdl-tooltip" data-mdl-for="disable-tooltip-' + index + '" id="control-' + index + '">' + control + ' ' + type + '</div>' +
            '<div class="mdl-tooltip" data-mdl-for="delete-tooltip-' + index + '">' + chrome.i18n.getMessage("remove") + ' ' + type + '</div>' +
            '<div class="mdl-tooltip" data-mdl-for="detail-tooltip-' + index + '">' + chrome.i18n.getMessage("detail") + ' ' + type + '</div>' +
            '<div class="hidden" id="detail-tooltip-more-' + index + '">'+
                '<img src="' + img + '" style="display: block; width: 50px;margin: auto;position: relative;padding-bottom: 10px;padding-top: 10px;"/>' +
                '<span style="display: block;margin-bottom: 5px;">Title: <span style="color: #b4b3b3;">' + name + '</span></span>' +
                '<span style="display: block;margin-bottom: 5px;">Description: <span style="color: #b4b3b3;">' + desc + '</span></span>' +
                '<span style="display: block;margin-bottom: 5px;"> How the extension was installed? <span style="display: block;color: #b4b3b3;">' + typeMap[installType] + '</span></span>' +
                '<span style="display: block;margin-bottom: 5px;"> Permissions: <span style="color: #b4b3b3;">' + permissions.join(", ") + '</span></span>' +
                '<span style="display: block;margin-bottom: 5px;"> Host permissions: <span style="color: #b4b3b3;">' + hsotPermission.join(", ") + '</span></span>' +
            '</div>'+
            '</li>');
    },
    search: function () {
        $("input.search").keyup(function () {
            var input, filter, ul, a, i;
            input = $(this);
            ul = $("#extensions").hasClass("active") ? $("#extList") : $("#appList");
            filter = $(this).val().toUpperCase();
            li = ul.children();
            for (i = 0; i < li.length; i++) {
                a = $(li[i]).find("span#title").html();
                if (a.toUpperCase().indexOf(filter) > -1) {
                    li[i].style.display = "";
                } else {
                    li[i].style.display = "none";
                }
            }
        });
    },
    showDetails: function () {
        $("span.btn-details").on("click", function () {
            var index = $(this).data('index');
            if ( $("#detail-tooltip-more-"+index).hasClass("hidden")){
                $("#detail-tooltip-more-"+index).removeClass("hidden");
            } else {
                $("#detail-tooltip-more-"+index).addClass("hidden");
            }
            
        });
    },
    disableEnableExt: function () {
        $("input[type=checkbox]").on("change", function () {
            var id = $(this).data('id');
            var index = $(this).data('index');
            var isChecked = $(this).is(':checked');
            if (isChecked) {
                chrome.management.setEnabled(id, true);
                $("#control-" + index).html("Disable extension");
            } else {
                chrome.management.setEnabled(id, false);
                $("#control-" + index).html("Enable extension");
            }
        });
    },
    uninstallExt: function () {
        $("span.btn-delete").on("click", function () {
            var id = $(this).data('id');
            chrome.management.uninstall(id);
            chrome.management.onUninstalled.addListener(function () {
                $("#extList").find("#" + id).remove();
            });
        });
    },
    // setShare: function () {
    //     var id = chrome.runtime.id;
    //     var share = document.createElement("IFRAME");
    //     var shareDiv = document.getElementById("share");
    //     share.setAttribute("src", "https://www.facebook.com/plugins/share_button.php?href=https%3A%2F%2Fchrome.google.com%2Fwebstore%2Fdetail%2F" + id + "&layout=button&size=large&mobile_iframe=false&width=73&height=28&appId");
    //     share.setAttribute("width", "73");
    //     share.setAttribute("height", "28");
    //     share.setAttribute("style", "border:none;overflow:hidden");
    //     share.setAttribute("scrolling", "no");
    //     share.setAttribute("frameborder", "0");
    //     share.setAttribute("allowTransparency", "true");
    //     shareDiv.appendChild(share);
    // },
    // setLike: function () {
    //     var like = document.createElement("IFRAME");
    //     var likeDiv = document.getElementById("like");
    //     like.setAttribute("src", "https://www.facebook.com/plugins/like.php?href=https%3A%2F%2Fwww.facebook.com%2FDelveNext%2F&width=63&layout=button&action=like&size=large&show_faces=false&share=false&height=65&appId");
    //     like.setAttribute("width", "63");
    //     like.setAttribute("height", "65");
    //     like.setAttribute("style", "border:none;overflow:hidden");
    //     like.setAttribute("scrolling", "no");
    //     like.setAttribute("frameborder", "0");
    //     like.setAttribute("allowTransparency", "true");
    //     likeDiv.appendChild(like);
    // },

    getList: function (data, index, elemId, type) {
        var desc, img, name, enabled, control, id, permissions, hsotPermission;
        desc = data.description.substr(0, 70);
        img = data.icons[data.icons.length - 1].url;
        name = data.name;
        enabled = data.enabled ? 'checked' : '';
        control = data.enabled ? chrome.i18n.getMessage("disable") : chrome.i18n.getMessage("enable");
        id = data.id;
        permissions = data.permissions;
        hsotPermission = data.hostPermissions;
        installType = data.installType;
        popup.createList(elemId, name, desc, img, index, enabled, id, control, type, permissions, hsotPermission, installType);
    },
    checkIfRated: function () {
        chrome.storage.local.get("isRated", (item) => {
          if (Object.keys(item).length > 0) {
            if (!item.isRated) {
              $("#rating").removeClass("hide");
              $("#rating").addClass("show");
            } else {
              $("#rating").addClass("hide");
              $("#rating").removeClass("show");
            }
          } else {
            $("#rating").removeClass("hide");
            $("#rating").addClass("show");
          }
        });
      },
    
      saveRating: function () {
        chrome.storage.local.set({ isRated: true });
      },

      checkIfDonated: function () {
        chrome.storage.local.get("isDonated", (item) => {
          if (Object.keys(item).length > 0) {
            if (!item.isDonated) {
              $("#donate").removeClass("hide");
              $("#donate").addClass("show");
            } else {
              $("#donate").addClass("hide");
              $("#donate").removeClass("show");
            }
          } else {
            $("#donate").removeClass("hide");
            $("#donate").addClass("show");
          }
        });
      },

    //   saveDonate: function () {
    //     chrome.storage.local.set({ isDonated: true });
    //   }
};

chrome.management.getAll(function (result) {
    popup.checkIfRated();
    //popup.checkIfDonated();
    for (var i = 0; i < result.length; i++) {
        if ((result[i].type === "extension" || result[i].type === "login_screen_extension") && result[i].id !== chrome.runtime.id) {
            popup.getList(result[i], i, "extList", chrome.i18n.getMessage("extension"));
        } else if (result[i].type === "hosted_app" || result[i].type === "packaged_app"
            || result[i].type === "legacy_packaged_app") {
            popup.getList(result[i], i, "appList", chrome.i18n.getMessage("app"));
        }
    }
    popup.disableEnableExt();
    popup.uninstallExt();
    popup.showDetails();
    popup.search();
    $(document).ready(function () {
        $("[data-trans]").each(function (i, e) {
            var tagName = e.tagName;
            var element = $(e);
            var message = element.attr("data-trans");
            if (tagName === "INPUT") {
                element.attr("placeholder", chrome.i18n.getMessage(message));
            } else {
                element.html(chrome.i18n.getMessage(message));
            }
        });
        rating();
    });
});

function rating() {

    /* 1. Visualizing things on Hover - See next part for action on click */
    $('#stars li').on('mouseover', function () {
        var onStar = parseInt($(this).data('value'), 10); // The star currently mouse on

        // Now highlight all the stars that's not after the current hovered star
        $(this).parent().children('li.star').each(function (e) {
            if (e < onStar) {
                $(this).addClass('hover');
            }
            else {
                $(this).removeClass('hover');
            }
        });

    }).on('mouseout', function () {
        $(this).parent().children('li.star').each(function (e) {
            $(this).removeClass('hover');
        });
    });


    /* 2. Action to perform on click */
    $('#stars li').on('click', function () {
        var onStar = parseInt($(this).data('value'), 10); // The star currently selected
        var stars = $(this).parent().children('li.star');

        for (i = 0; i < stars.length; i++) {
            $(stars[i]).removeClass('selected');
        }

        for (i = 0; i < onStar; i++) {
            $(stars[i]).addClass('selected');
        }

        // JUST RESPONSE (Not needed)
        var ratingValue = parseInt($('#stars li.selected').last().data('value'), 10);
        var msg = "";
        popup.saveRating();
        if (ratingValue > 3) {
            msg = "Thanks! You rock";
            chrome.tabs.create({ url: "https://chrome.google.com/webstore/detail/extension-manager-for-chr/" + chrome.runtime.id + "/reviews" });
        } else {
            msg = "We will improve ourselves";
        }
        $("#greeding-card").removeClass("hide");
        $("#greeding-card").addClass("show");
        setTimeout(() => {
            $("#greeding-card").removeClass("show");
            $("#greeding-card").addClass("hide");
            $("#rating").removeClass("show");
            $("#rating").addClass("hide");
        }, 2000);
        responseMessage(msg);
    });
};


function responseMessage(msg) {
    $('.success-box').fadeIn(200);
    $('.success-box div.text-message').html("<span>" + msg + "</span>");
}